Include "mapengine\mapengine.bb"


;----------------------------------------------------------------------




Global startx,goneX,posx,starty,goneY,posy,animframe,endx,endy,gox,goy
Global Figur,jump,jumper,jumpery#
Global Richtung,Frames,FPS
Global Blink,time,getrtime,enemyanimtime%

Dim map(0,0,0)
Dim gegner_pic(1)

Type enemy
	Field art
	Field X#
	Field Y#
	Field Richtung
	Field Anim
End Type

Type Staub
	Field x
	Field y
	Field anim
End Type
	
;----------------------------------------------------------------------


command$=Trim$(CommandLine$()); Auto Map Load


Global gw,gh,gb,gm

stream=ReadFile("setup.cfg")
Gw=ReadLine(stream)
Gh=ReadLine(stream)
Gb=ReadLine(stream)
Gm=ReadLine(stream)
CloseFile(stream)



lvl = 1

Global win
Global Canvas

;If command$="" Then
  width   =gw
  height  =gh
  depth   =gb
  If gm <> 2  
	Graphics width,height,depth,gm
  Else 
	win=CreateWindow("Jump and Run",0,0,gw+6,gh+32,0,1+2)
	Canvas=CreateCanvas(0,0,gw,gh,win)
	SetGadgetLayout canvas,1,1,1,1
  EndIf
  ;
;EndIf

;----------------------------------------------------------------------



Figur = LoadAnimImage("data\figur\player.bmp",32,32,0,8)
MaskImage Figur,255,0,255
gegner_pic(0) = LoadAnimImage("data\figur\maus.bmp",32,32,0,8)
MaskImage gegner_pic(0),255,0,255
gegner_pic(1) = LoadAnimImage("data\figur\maus.bmp",32,32,0,8)
MaskImage gegner_pic(1),255,0,255
muenze = LoadAnimImage("data\item\Muenze.bmp",32,32,0,6)
MaskImage muenze,255,0,255
Herz = LoadImage("data\item\herz.bmp")
MaskImage Herz,255,0,255
jump = LoadAnimImage("data\figur\jump.bmp",64,32,0,6)
MaskImage jump,255,0,255
jumper = LoadAnimImage("data\item\jumper.bmp",32,32,0,2)
MaskImage jumper,255,0,255

;----------------------------------------------------------------------

;----------------------------------------------------------------------
Menu= LoadImage("Data\schrift_menue.PNG")
ResizeImage Menu,gw,gh
If gm<>2 Then
	SetBuffer BackBuffer()
Else
	SetBuffer CanvasBuffer(canvas)
EndIf

fntArial =LoadFont("Arial",gh/10,False,False,False)

fntArial2 =LoadFont("Arial",gh/20,False,False,False)



.menue
l=0
SetFont fntArial
FlushKeys

Marquee_txt$="Elephant World"
m=gw
Repeat 
	Cls
	
	If KeyHit(200) l = l-1
	If KeyHit(208) l = l+1
	If KeyHit(203) l = l-1
	If KeyHit(205) l = l+1	
	If l < 0 Then l = 3
	If l > 3 Then l = 0

	DrawImage Menu,0,0
	m = m-1
	If m < -gw*1.2 Then m=gw+10
	Color 55,55,55
	Text gw/2,gh/6*2,"Neues Spiel",1,1	
	Text gw/2,gh/6*3,"Spiel laden",1,1	
	Text gw/2,gh/6*4,"Credits",1,1	
	Text gw/2,gh/6*5,"Beednen",1,1
	Text m+1,1,Marquee_txt$
	Text m-1,1,Marquee_txt$
	Text m+1,-1,Marquee_txt$
	Text m-1,-1,Marquee_txt$
	Color 255,255,255
	Text m,0,Marquee_txt$
	If l = 0 Then Color 255,0,0
	Text gw/2+2,gh/6*2+2,"Neues Spiel",1,1	
	If l = 0 Then Color 255,255,255
	If l = 1 Then Color 255,0,0
	Text gw/2-2,gh/6*3+2,"Spiel laden",1,1
	If l = 1 Then Color 255,255,255
	If l = 2 Then Color 255,0,0	
	Text gw/2+2,gh/6*4-2,"Credits",1,1	
	If l = 2 Then Color 255,255,255
	If l = 3 Then Color 255,0,0
	Text gw/2-2,gh/6*5-2,"Beednen",1,1	
	If l = 3 Then Color 255,255,255
	If gm<>2
		Flip 0
	Else
		FlipCanvas canvas
	EndIf
Until KeyHit(28)+KeyHit(56)

lvl=1
If l = 3 Then End
If l = 1 Then 
	Stream=ReadFile("Data\Save\Save.dat")
	If stream 
		g1=ReadInt(stream)
		g2=ReadInt(stream)	
		CloseFile(stream)
		g1 = g1 Xor Int(13)
		g2 = g2 Xor Int(13)
		If g2 = Int(Sqr(g1)) Then LVL = g1
	EndIf
EndIf
If l = 2 Then Goto credits

SetFont fntArial2
;----------------------------------------------------------------------
l=0
.start
FlushKeys
If command$= ""
	name$ = "data\Map\"+lvl+".map"
Else
	name$ = "data\Map\"+command$+".map"
EndIf
map_reset()
error=map_load(name$,passw$)
Color 0,0,0

If error>0 Then EndGraphics
Select error
  Case 1
    RuntimeError "File not found"
  Case 2
    RuntimeError "File size corrupted"
  Case 3
    RuntimeError "No read access"
  Case 4
    RuntimeError "Not valid file"
  Case 5
    RuntimeError "Checksum problem"
  Case 6
    RuntimeError "Password problem"
  Case 7
    RuntimeError "Load image problem"
End Select
If error>0 Then End
;----------------------------------------------------------------------

For layer.layer = Each layer
	;Data for the Collisions
	;Daten fr die Kollisionen
	If Upper(layer\name$)  = "PLAYER" Then 
		mapwidth =layer\sizeX
		mapheight =layer\sizeY
		PosX = layer\Posx
		posy = layer\posy
		muenzanz = 0
		Dim map(layer\sizeX,layer\sizeY,1)
		For x = 0 To layer\sizeX
			For y = 0 To layer\sizeY
				map(X,Y,0)= layer_getvalue(layer,x,y)
				map(X,Y,1)= layer_getdata(layer,x,y)
				If map(X,Y,1)=1 Then realx=x:posy=y*32
				If map(X,Y,1)=3 Then muenzanz =muenzanz +1
				If map(X,Y,1)=4 Then map(X,Y,0) = 1
				If map(X,Y,1)>9 Then
					gegner.enemy = New enemy
					gegner\x=x*32
					gegner\y=y*32
					gegner\art = map(X,Y,1)-10
					gegner\anim = 1
				EndIf
			Next
		Next
	EndIf
Next

;----------------------------------------------------------------------
Herzen = 4
;----------------------------------------------------------------------

;Stop
Repeat
  t2=t1:t1 = MilliSecs():Fps = 1000.0/(t1-t2)
  If FPS < 20 Then FPS = 20

  If gameover = 0 Then
	time =  MilliSecs()
	If fallen#= oldfallen# And fallen# < 0
		fallerr = fallerr+1
	Else
		fallerr = 0
	EndIf
	If fallerr = 2 Then fallen#=0
	
	
	oldfallen# = fallen#
	posx = realx*32+gonex
	If posy >-1 Then
		If Map(realx,(posy/32)+1,0) = 0 Then 
			fallen# = fallen#+(30.0/FPS)
			If fallen# > 30 Then fallen# =30
		Else
			posy=Int(posy/32)*32
			If fallen# >0 Then fallen# =0
		EndIf
		If map(posx/32.0,posy/32.0,1) = 3 			Then points =points + 25:map( posx/32.0    ,posy/32.0     ,1)=0
		If map((posx+32)/32.0,(posy+32)/32.0,1) = 3	Then points =points + 25:map((posx+32)/32.0,(posy+32)/32.0,1)=0 
		If map(posx/32.0,(posy+32)/32.0,1) = 4 		Then fallen = -22		:jumpery#=-3200
		If map((posx+32)/32.0,(posy+32)/32.0,1) = 2 Then lvl = lvl +1		:ende = 2   
		If map((posx)/32.0,(posy)/32.0,1) = 2 		Then lvl = lvl +1		:ende = 2                   
		
	Else
		If fallen# <0 Then fallen# =45.0
	EndIf
	jumpery#= jumpery#*(0.95)
	posy = posy+((fallen#*60.0)/FPS)
	map_scrolly=(5*map_scrolly+16+posy - gw/2)/6
	map_scrollx=(5*map_scrollx+16+posx - gh/2)/6
	
	If KeyHit(1) Then ende=3
	
	If fallen# < 0 Then 
		If map(realx,Int(posy/32.0)-1,0)<>0 Then
			If map(realx,Int(posy/32.0)-1,1)<>5
				fallen# = fallen#*-0.10
			EndIf
		End If
	EndIf
	If KeyHit(200) Then
		If fallen# +oldfallen#=0 Then fallen#=-14.0 ;oben
	EndIf
	

	If KeyDown(205) Then ;rechts
		Richtung = 1 
		If map(realx + 1,Int(posy/32.0),0)=0 Then
			speed# = Speed#+0.5
			gonex=gonex+(speed#*60.0/fps)
			If Frames = 0 Then Animframe=(1+Zaehler)*2:Zaehler = 1-Zaehler
			If speed# < 0 Then Animframe=3*2
			If gonex > 24 Then realx =realx+1:gonex= gonex -32
		Else 
			gonex=0
		EndIf
	EndIf
	
	If gonex <0 Then 
		If map(realx-1,posy/32.0,0) <>0 Then gonex=0
	Else
		If map(realx+1,posy/32.0,0) <>0 Then gonex=0
	EndIf
	
	If KeyDown(203) Then 
			Richtung = 0 
		If map(realx - 1,Int(posy/32.0),0)=0 Then
			speed# = Speed#-0.5
			gonex=gonex+(speed#*60.0/fps)
			If Frames = 1 Then Animframe=(1+Zaehler)*2:Zaehler = 1-Zaehler
			If speed# > 0 Then Animframe=3*2
			If gonex < -24 Then realx =realx-1:gonex= gonex +32
		Else 
			gonex=0
		EndIf
	EndIf
	If fallen# <> 0 Then 
		Animframe=0
	Else If Animframe=0 And oldfallen# = 0
		Animframe=4
	EndIf
	
	For gegner.enemy = Each enemy
		m=0
		If fallen# > 0 Then
			If realx = Int(gegner\x/32.0) And Int(posy/32.0)+1 = Int(gegner\y/32.0)
				getroffen.staub = New staub
				getroffen\x = gegner\x-16
				getroffen\y = gegner\y
				getroffen\anim=0
				points = points + (gegner\art+1) * 50
				fallen# = -8.5
				Delete gegner
				m=1
			ElseIf realx = Int((gegner\x+24)/32.0) And Int(posy/32.0)+1 = Int(gegner\y/32.0)
				getroffen.staub = New staub
				getroffen\x = gegner\x-16
				getroffen\y = gegner\y
				getroffen\anim=0
				points = points + (gegner\art+1) * 50
				fallen# = -8.5
				Delete gegner
				m=1
			ElseIf realx = Int((gegner\x-24)/32.0) And Int(posy/32.0)+1 = Int(gegner\y/32.0)
				getroffen.staub = New staub
				getroffen\x = gegner\x-16
				getroffen\y = gegner\y
				getroffen\anim=0
				points = points + (gegner\art+1) * 50
				fallen# = -8.5
				Delete gegner
				m=1
			EndIf	
		EndIf
		If m = 0 Then
			If getrtime < time Then
				If realx = Int(gegner\x/32.0) And Int(posy/32.0) = Int(gegner\y/32.0)
					If ImagesCollide (figur, posx, posy, 0, gegner_pic(gegner\art), gegner\x, gegner\y, gegner\anim)
						Herzen = herzen -1
						getrtime = time + 5000
						If herzen < 0 Then Gameover=1
					EndIf
				EndIf
			EndIf
		EndIf
	Next
	speed# = speed#/1.1

	If map_scrolly <0 map_scrolly=0
	If map_scrollx <0 map_scrollx=0
	If map_scrolly >mapheight*32-gh map_scrolly=mapheight*32-gh
	If map_scrollx >mapwidth*32-gw  map_scrollx=mapwidth*32-gw
	
  Else
	posy = posy -3
	lost = lost + 1
	If lost = gh/4 Then ende = 1
  EndIf
	
	Frames = Frames+1
	If Frames > fps/10 Then Frames =0
	If frames = 0 Then muenzanim=muenzanim + 1
	If muenzanim > 5 Then muenzanim = 0
	abc=0	
	tile_animate()
	draw_map()

	For x = 0 To mapwidth
		For y = 0 To mapheight
			If (x+1) Shl 5 -map_scrollx > 0 And x Shl 5-map_scrollx < gw And (y+1) Shl 5-map_scrolly > 0 And y Shl 5-map_scrolly < gh Then
				Select map(x,y,1)
				Case 3
					DrawImage muenze,x*32-map_scrollx,y*32-map_scrolly,muenzanim
				Case 4
					DrawImage jumper,x*32-map_scrollx,y*32-map_scrolly+(jumpery#/100.0),1
					DrawImage jumper,x*32-map_scrollx,y*32-map_scrolly,0
				End Select
			EndIf
		Next
	Next 
	If KeyHit(67) Then Stop
	poi$=points
	l=Len(poi$)
	For m=l To 8
		poi$ = "0"+poi$
	Next
	
	Color 100,100,100
	Text 10,25, poi$+" Punkte"
	Color 255,128,64
	Text 11,26, poi$+" Punkte"
	For g = 0 To Herzen
		DrawImage Herz,g*48,gh-48
	Next

	;Text 0,0,"FPS: " + FPS
  If gm<> 2
	  Flip 1
  Else
	  FlipCanvas canvas,1
  EndIf
Until ende

;--------------------------------
;unload
;--------------------------------

For gegner.enemy = Each enemy
	Delete gegner
Next
For x = 0 To mapwidth
	For y = 0 To mapheight
		map(X,Y,0)=0
		map(X,Y,1)=0
	Next
Next 
For getroffen.staub = Each staub
	Delete getroffen
Next
mapwidth	=0
mapheight	=0
map_scrolly	=0
map_scrollx	=0
realx		=0
posx		=0
posy		=0
gonex		=0
goney		=0
fallen		=0
oldfallen	=0 
frames		=0
lost		=0
animframe	=0
speed		=0
Richtung	=0
fallerr		=0
gameover	=0
x			=0
y			=0
FPS			=260
t3			=0
t2			=0
t1			=0
m			=0
l			=0
map_reset()
For layer.layer = Each layer
	Delete Layer
Next
If ende = 2 Then 
	Stream=WriteFile("Data\Save\Save.dat")
	WriteInt stream,lvl Xor Int(13)
	WriteInt stream,(Sqr(lvl)) Xor (Int(13))
	WriteInt stream,points Xor Int(13)
	WriteInt stream,(Sqr(points)) Xor (Int(13))
	CloseFile(stream)
	ende =0:Goto start
Else
	points = 0 :ende = 0:Goto menue
EndIf

End

Function draw_map()
  Local b
  Local g
  Local layer.layer
  Local px
  Local py
  Local r
  Local changeenemy=0
  If time > enemyanimtime + 20 Then
	changeenemy=1
	enemyanimtime = time
  EndIf
  Viewport map_x, map_y, map_width, map_height
  Origin map_x, map_y

  If map_visible=1 Then
	If map_mode=2 And map_image<>0 Then
      px=map_getscreen(map_posx,map_parax,map_scrollx)
      py=map_getscreen(map_posy,map_paray,map_scrolly)
      TileBlock map_image,px,py
    ElseIf map_mode=3 And map_image<>0 Then
      px=map_getscreen(map_posx,map_parax,map_scrollx)
      py=map_getscreen(map_posy,map_paray,map_scrolly)
      TileImage map_image,px,py
    EndIf
  EndIf

  For layer=Each layer
    If layer\visible=1 Then
      Select layer\code
        Case layer_map
          layer_map_draw(layer)
        Case layer_clone
          layer_clone_draw(layer)
        Case layer_image
          layer_image_draw(layer)
        Case layer_block
          layer_block_draw(layer)
      End Select

    EndIf

	If Upper(layer\name$) = "PLAYER" Then 
		If getrtime > time Then
			blink = 1- blink
		Else
			blink = 0 
		EndIf
		If blink = 0 Then DrawImage Figur,posx-map_scrollx,posy-map_scrolly,Int(Animframe )+Richtung
		For gegner.enemy = Each enemy
			If gegner\richtung = 1 Then 
				If map(gegner\x/32.0+1,gegner\y/32.0,0) = 0 Then
					If map(gegner\x/32+1.0,gegner\y/32+1.0,0) = 0 Then
						gegner\richtung = 1- gegner\richtung
						gegner\anim = 6
					Else
						If gegner\art = 1 Then
							gegner\x = gegner\x +2.0*60.0/FPS
						Else
							gegner\x = gegner\x +1.0*60.0/FPS
						EndIf
						If frames = 0 Then
							If changeenemy=1
								If gegner\anim = 2 Then gegner\anim = 4 Else gegner\anim = 2
							EndIf
						EndIf
					EndIf
				Else
					gegner\richtung = 1- gegner\richtung
					gegner\anim = 6
				EndIf
			Else
				If map((gegner\x-16)/32.0,gegner\y/32.0,0) = 0 Then
					If map((gegner\x-16)/32.0,gegner\y/32+1.0,0) = 0 Then
						gegner\richtung = 1- gegner\richtung
						gegner\anim = 6
					Else
						If gegner\art = 1 Then
							gegner\x = gegner\x -2.0*60.0/FPS
						Else
							gegner\x = gegner\x -1.0*60.0/FPS
						EndIf
						If frames = 0 Then 
							If changeenemy=1
								If gegner\anim = 2 Then gegner\anim = 4 Else gegner\anim = 2
							EndIf
						EndIf
					EndIf
				Else
					gegner\richtung = 1- gegner\richtung
					gegner\anim = 6
				EndIf
			EndIf
			If gegner\x-map_scrollx+32 > 0 And gegner\x-map_scrollx < gw And gegner\y-map_scrolly+32 > 0 And gegner\y-map_scrolly < gh Then
				DrawImage gegner_pic(gegner\art),gegner\x-map_scrollx,gegner\y-map_scrolly,gegner\Anim+gegner\richtung
			EndIf
		Next
		For getroffen.staub = Each staub
			DrawImage jump,getroffen\x-map_scrollx,getroffen\y-map_scrolly,getroffen\anim
			If frames = 0 Then 
				getroffen\anim = getroffen\anim +1
				If getroffen\anim > 5 Then Delete getroffen
			EndIf
		Next		
	EndIf
  Next
End Function

.Credits
g= 0
SetFont fntArial2
Repeat
Cls
g=g-1
Text gw/2,gh+g,"Hier kommen die Credits herrein.",1,0
Text gw/2,gh+g+(FontHeight()*1),"Jan Kuhnert",1,0
Text gw/2,gh+g+(FontHeight()*2),"Programmierer",1,0

  If gm<> 2
	  Flip 0
  Else
	  FlipCanvas canvas,0
  EndIf
Until KeyHit(1)
SetFont fntArial
Goto menue





